//
//  $Id: PrintCardForm.h,v 1.3 2000/06/06 09:30:46 sergey Exp $
//

#ifndef _PrintCardForm_h_
#define _PrintCardForm_h_

#include "UI/Form.h"
#include "UI/List.h"
#include "UI/PopupList.h"
#include "PrintStatusForm.h"
#include "PrintCardModel.h"


class PrintCardForm: public UI::Form
{
public:
    PrintCardForm();

// operations

    virtual void create();

// event handlers

    virtual bool eventHandler(EventType* event);

protected:
    virtual bool handleOpenFormEvent(Word formID);
    virtual bool handleUpdateFormEvent(Word formID);
    virtual bool handleCtlSelectEvent(Word controlID, bool on);
    virtual bool handleMenuEvent(Word itemID);
    virtual bool handleKeyDownEvent(char asciiChar, Word keyCode, Word modifiers);

// implememntation
private:
    void initNamesList();
    void initCardsList();

    void namesListSelected(int index);
    void cardsListSelected(int index);

    void drawPreviewImage();
    void drawPreviewImage(BitmapPtr image);

    void showDefaultPreviewImage();
    void hideDefaultPreviewImage();
    void getPreviewImagePosition(short& x, short& y) const;

// data members
private:
    UI::PopupList   _names;
    UI::List        _cards;

    PrintCardModel  _model;
};

#endif  // _PrintCardForm_h_
